/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#include "chunker.h"

void RanalyticSolve(void)
{
	real k11, k12, k22;
	real *ptr;
	real d = alpha_new[0] + alpha_new[1];
	real L, H;
	real x1min, x1max, x2min, x2max;
	real eta;

	ptr = K_SP;
	k11 = *ptr++;
	k12 = *ptr++;
	k22 = *(ptr+1);
	
	if(CL_SP[0] < 0)
	{
		x1min = -C;
		x1max =  0;
	}
	else
	{
		x1min =  0;
		x1max =  C;
	}

	if(CL_SP[1] < 0)
	{
		x2min = -C;
		x2max =  0;
	}
	else
	{
		x2min =  0;
		x2max =  C;
	}
	
	{
		real ww = d - x2max;
		L = ((ww > x1min) ? ww :  x1min);
		ww = d - x2min;
		H = ((ww < x1max) ? ww  : x1max);
	}

	eta = k11 - 2*k12 + k22;

	if(eta > 0)
	{
		real alph = ((k22 - k12)*d + b_SP[0] - b_SP[1])/eta;
	
		if(alph > H)
			alph = H;
		else
		{
			if(alph < L)
				alph = L;
		}
    
		alpha_new[0] = alph;
		alpha_new[1] = d - alph;
	}
	else
	{
		real alph = (k12 - k22)*d + b_SP[1] - b_SP[0];
		if(alph > 0)
		{
			alpha_new[0] = L;
			alpha_new[1] = d - L;
		}
		else
		{
			alpha_new[0] = H;
			alpha_new[1] = d - H;
		}
	}
}
